package view;

public class GameChooserPanel extends javax.swing.JPanel {

    public GameChooserPanel() {
        initComponents();
    }
    
    public GameMode getGameMode(){
        if (rbLocal.isSelected())
            return GameMode.LOCAL;
        else if (rbHost.isSelected())
            return GameMode.SERVER;
        else 
            return GameMode.CLIENT;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        bGroup = new javax.swing.ButtonGroup();
        rbLocal = new javax.swing.JRadioButton();
        rbHost = new javax.swing.JRadioButton();
        rbClient = new javax.swing.JRadioButton();
        txtAddress = new javax.swing.JTextField();
        lblAddress = new javax.swing.JLabel();
        lblPort = new javax.swing.JLabel();
        txtPort = new javax.swing.JTextField();

        bGroup.add(rbLocal);
        rbLocal.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        rbLocal.setSelected(true);
        rbLocal.setText("Start a two player local game");
        rbLocal.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbLocalActionPerformed(evt);
            }
        });

        bGroup.add(rbHost);
        rbHost.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        rbHost.setText("Create a two player LAN server / game");
        rbHost.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbHostActionPerformed(evt);
            }
        });

        bGroup.add(rbClient);
        rbClient.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        rbClient.setText("Join a game");
        rbClient.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbClientActionPerformed(evt);
            }
        });

        txtAddress.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        txtAddress.setText("localhost");
        txtAddress.setEnabled(false);

        lblAddress.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        lblAddress.setText("Address:");

        lblPort.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        lblPort.setText("Port:");

        txtPort.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        txtPort.setText("5000");
        txtPort.setEnabled(false);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(rbLocal)
                            .addComponent(rbHost)
                            .addComponent(rbClient))
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(28, 28, 28)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(lblPort)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 43, Short.MAX_VALUE)
                                .addComponent(txtPort, javax.swing.GroupLayout.PREFERRED_SIZE, 78, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(286, 286, 286))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(lblAddress)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(txtAddress)))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(rbLocal)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(rbHost)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(rbClient)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtAddress, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lblAddress))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblPort)
                    .addComponent(txtPort, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void rbLocalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbLocalActionPerformed
        txtAddress.setEnabled(false);
        txtPort.setEnabled(false);
    }//GEN-LAST:event_rbLocalActionPerformed

    private void rbHostActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbHostActionPerformed
        txtAddress.setEnabled(false);
        txtPort.setEnabled(false);
    }//GEN-LAST:event_rbHostActionPerformed

    private void rbClientActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbClientActionPerformed
        txtAddress.setEnabled(true);
        txtPort.setEnabled(false);
    }//GEN-LAST:event_rbClientActionPerformed

    public String getAddress(){
        return txtAddress.getText();
    }
    
    public int getPort(){
        return 5000;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup bGroup;
    private javax.swing.JLabel lblAddress;
    private javax.swing.JLabel lblPort;
    private javax.swing.JRadioButton rbClient;
    private javax.swing.JRadioButton rbHost;
    private javax.swing.JRadioButton rbLocal;
    private javax.swing.JTextField txtAddress;
    private javax.swing.JTextField txtPort;
    // End of variables declaration//GEN-END:variables
}
