package model;

import networking.GameBoardClient;
import java.io.IOException;
import java.io.PipedInputStream;
import java.io.PipedOutputStream;
import org.junit.Test;
import static org.junit.Assert.*;

public class GameBoardTester {
    
    @Test
    public void testGameBoardTransmission() throws IOException{
        final PipedInputStream pis = new PipedInputStream();
        final PipedOutputStream pos = new PipedOutputStream();
        pis.connect(pos);

        GameBoard board = new GameBoard();
        board.getPlayer(0).setSmoothCoord(100, 210);
        board.getPlayer(1).faceDir = Direction.DOWN;
        board.table[1][1] = Item.EMPTY;
        pos.write(board.toByteArray());
        board.table[1][2] = Item.EMPTY;
        pos.write(board.toByteArray());
        
        GameBoardClient proxy = new GameBoardClient(pis, pos, null);
        
        byte buf[] = new byte[proxy.representationSize];

        pis.read(buf);
        proxy.fromByteArray(buf);
        assertTrue(board.getPlayer(0).smoothPos.equals(proxy.getPlayer(0).smoothPos));
        assertTrue(board.getPlayer(1).faceDir == proxy.getPlayer(1).faceDir);
        assertTrue(board.table[1][1] == proxy.table[1][1]);
        assertFalse(board.table[1][2] == proxy.table[1][2]);

        pis.read(buf);
        proxy.fromByteArray(buf);
        assertTrue(board.table[1][2] == proxy.table[1][2]);
    }
}
